# Copyright (C) 2016-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

snafu: runtime loadtime

runtime: SNAFU.DLL SNAFU.EXE
	"$(MAKEDIR)\SNAFU.EXE"

loadtime: SNAFU.COM SNAFU.DLL
	"$(MAKEDIR)\SNAFU.COM"

clobber: clean
	Erase SNAFU.COM SNAFU.DLL SNAFU.EXE

clean:
	Erase SNAFU.EXP SNAFU.LIB SNAFU.LOG SNAFU.OBJ SNAFU.TMP

SNAFU.OBJ: SNAFU.MAK
#	CL.EXE /Brepro /c /DLCU=0 /DSNAFU=const /FoSNAFU.OBJ /GA /GF /Gw /Gy /nologo /Tc<< /W4 /Zl
	CL.EXE /Brepro /c /DLCU=0 /DSNAFU=static /FoSNAFU.OBJ /GA /GF /Gw /Gy /nologo /Tc<< /W4 /Zl
// Copyright (C) 2016-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifndef _WIN64
SNAFU	DWORD	__security_cookie = 0xBB40E64EUL;
		               // = 3141592654 = 10**9 * pi

// https://msdn.microsoft.com/en-us/library/9a89h429.aspx

extern	LPVOID	__safe_se_handler_table[];
extern	BYTE	__safe_se_handler_count;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_32
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD	DeCommitFreeBlockThreshold;
	DWORD	DeCommitTotalFreeThreshold;
	DWORD	LockPrefixTable;
	DWORD	MaximumAllocationSize;
	DWORD	VirtualMemoryThreshold;
	DWORD	ProcessHeapFlags;
	DWORD	ProcessAffinityMask;
	WORD	CSDVersion;
#if LCU > 2				// Redstone 1 (1607)
	WORD	DependentLoadFlags;
#else
	WORD	Reserved1;
#endif
	DWORD	EditList;
	DWORD	SecurityCookie;
	DWORD	SEHandlerTable;
	DWORD	SEHandlerCount;
#if LCU > 0				// Threshold 1 (1507)
	DWORD	GuardCFCheckFunctionPointer;
	DWORD	GuardCFDispatchFunctionPointer;
	DWORD	GuardCFFunctionTable;
	DWORD	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 1				// Threshold 2 (1511)
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 2				// Redstone 1 (1607)
	DWORD	GuardAddressTakenIatEntryTable;
	DWORD	GuardAddressTakenIatEntryCount;
	DWORD	GuardLongJumpTargetTable;
	DWORD	GuardLongJumpTargetCount;
	DWORD	DynamicValueRelocTable;
	DWORD	CHPEMetadataPointer;
#if LCU > 3				// Redstone 2 (1703)
	DWORD	GuardRFFailureRoutine;
	DWORD	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 4				// Redstone 3 (1709)
	DWORD	Reserved3;
	DWORD	EnclaveConfigurationPointer;
#if LCU > 5				// Redstone 4 (1803)
	DWORD	VolatileMetadataPointer;
#if LCU > 6				// Redstone 5 (1809)
	DWORD	GuardEHContinuationTable;
	DWORD	GuardEHContinuationCount;
					// Titanium (1903)
					// Vanadium (1909)
					// Vibranium 1 (2004)
					// Vibranium 2 (20H2)
#if LCU > 7				// Vibranium 3 (21H1)
	DWORD	GuardXFGCheckFunctionPointer;
	DWORD	GuardXFGDispatchFunctionPointer;
	DWORD	GuardXFGTableDispatchFunctionPointer;
#if LCU > 8				// Vibranium 4 (21H2)
	DWORD	CastGuardOsDeterminedFailureMode;
#if LCU > 9				// Vibranium 5 (22H2)
	DWORD	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used),
                       'OUCH',		// = Monday, 2012-03-05 22:50:48 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0UL,
                       0U,
                       2048U,
                       0UL,
                       &__security_cookie,
                       __safe_se_handler_table,
                       &__safe_se_handler_count};
#else // _WIN64
SNAFU	DWORD64	__security_cookie = 0x00002B992DDFA232ULL;
		               // = 3141592653589793241 >> 16
		               // = 10**18 / 2**16 * pi

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_64
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD64	DeCommitFreeBlockThreshold;
	DWORD64	DeCommitTotalFreeThreshold;
	DWORD64	LockPrefixTable;
	DWORD64	MaximumAllocationSize;
	DWORD64	VirtualMemoryThreshold;
	DWORD64	ProcessAffinityMask;
	DWORD	ProcessHeapFlags;
	WORD	CSDVersion;
#if LCU > 2				// Redstone 1 (1607)
	WORD	DependentLoadFlags;
#else
	WORD	Reserved1;
#endif
	DWORD64	EditList;
	DWORD64	SecurityCookie;
	DWORD64	SEHandlerTable;
	DWORD64	SEHandlerCount;
#if LCU > 0				// Threshold 1 (1507)
	DWORD64	GuardCFCheckFunctionPointer;
	DWORD64	GuardCFDispatchFunctionPointer;
	DWORD64	GuardCFFunctionTable;
	DWORD64	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 1				// Threshold 2 (1511)
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 2				// Redstone 1 (1607)
	DWORD64	GuardAddressTakenIatEntryTable;
	DWORD64	GuardAddressTakenIatEntryCount;
	DWORD64	GuardLongJumpTargetTable;
	DWORD64	GuardLongJumpTargetCount;
	DWORD64	DynamicValueRelocTable;
	DWORD64	CHPEMetadataPointer;
#if LCU > 3				// Redstone 2 (1703)
	DWORD64	GuardRFFailureRoutine;
	DWORD64	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD64	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 4				// Redstone 3 (1709)
	DWORD	Reserved3;
	DWORD64	EnclaveConfigurationPointer;
#if LCU > 5				// Redstone 4 (1803)
	DWORD64	VolatileMetadataPointer;
#if LCU > 6				// Redstone 5 (1809)
	DWORD64	GuardEHContinuationTable;
	DWORD64	GuardEHContinuationCount;
					// Titanium (1903)
					// Vanadium (1909)
					// Vibranium 1 (2004)
					// Vibranium 2 (20H2)
#if LCU > 7				// Vibranium 3 (21H1)
	DWORD64	GuardXFGCheckFunctionPointer;
	DWORD64	GuardXFGDispatchFunctionPointer;
	DWORD64	GuardXFGTableDispatchFunctionPointer;
#if LCU > 8				// Vibranium 4 (21H2)
	DWORD64	CastGuardOsDeterminedFailureMode;
#if LCU > 9				// Vibranium 5 (22H2)
	DWORD64	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used),
                       'OUCH',		// = Monday, 2012-03-05 22:50:48 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       0UL,
                       0UL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0U,
                       2048U,
                       0ULL,
                       &__security_cookie,
                       0ULL,
                       0ULL};
#endif // _WIN64
<<NOKEEP

SNAFU.COM: SNAFU.OBJ SNAFU.LIB SNAFU.MAK
	CL.EXE /Brepro /c /FoSNAFU.TMP /GA /GF /Gw /Gy /Gz /nologo /O2 /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2016-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

__declspec(dllimport)
extern	const	LONG	SNAFU;

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	WINAPI	WinMainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(SNAFU);
}
<<NOKEEP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:2048 /DYNAMICBASE /ENTRY:WinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:10.01 /OUT:SNAFU.COM /RELEASE /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /TEST /VERSION:0.815 SNAFU.TMP SNAFU.OBJ SNAFU.LIB

SNAFU.DLL SNAFU.LIB: SNAFU.OBJ SNAFU.MAK
	CL.EXE /Brepro /c /FoSNAFU.TMP /GA /GF /Gw /Gy /Gz /nologo /O2 /Tc<< /W4 /wd4100 /we4013 /Zl
// Copyright (C) 2016-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

const	LPCSTR	szReason[4] = {"DLL_PROCESS_DETACH",
		               "DLL_PROCESS_ATTACH",
		               "DLL_THREAD_ATTACH",
		               "DLL_THREAD_DETACH"};

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	// https://msdn.microsoft.com/en-us/library/ms645507.aspx

	MessageBoxExA(HWND_DESKTOP,
	              "Situation normal, all\b\b\bbut \"/DEPENDENTLOADFLAG\" fucked up!",
	              szReason[dwReason],
	              MB_OK,
	              MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL));

	return FALSE;
}

__declspec(dllexport)
const	LONG	SNAFU = 0x815L;
<<NOKEEP
	LINK.EXE /LINK /ALLOWBIND:NO /BREPRO /DEFAULTLIB:USER32.LIB /DEPENDENTLOADFLAG:2048 /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /EXPORT:SNAFU,DATA /IMPLIB:SNAFU.LIB /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:10.01 /OUT:SNAFU.DLL /RELEASE /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /TEST /VERSION:0.815 SNAFU.TMP SNAFU.OBJ

SNAFU.EXE: SNAFU.OBJ SNAFU.MAK
	CL.EXE /Brepro /c /FoSNAFU.TMP /GA /GF /Gw /Gy /Gz /nologo /O2 /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2016-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	WINAPI	WinMainCRTStartup(VOID)
{
	DWORD	dwError = ERROR_SUCCESS;

	// https://msdn.microsoft.com/en-us/library/ms684175.aspx

	HMODULE	hModule = LoadLibraryA("SNAFU.DLL");

	if (hModule == NULL)

		// https://msdn.microsoft.com/en-us/library/ms679360.aspx

		dwError =  GetLastError();
	else
		// https://msdn.microsoft.com/en-us/library/ms683152.aspx

		if (!FreeLibrary(hModule))
			dwError = GetLastError();

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEPENDENTLOADFLAG:2048 /DYNAMICBASE /ENTRY:WinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:10.01 /OUT:SNAFU.EXE /RELEASE /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /TEST /VERSION:0.815 SNAFU.TMP SNAFU.OBJ
	LINK.EXE /DUMP /HEADERS /LOADCONFIG /OUT:SNAFU.LOG SNAFU.EXE
